/* Set the Default property value for the first time the calculator is loaded*/
var propertyDefaultValue = 450000;
/* Set the Default loan value for the first time the calculator is loaded*/
var loanDefaultValue = 250000;
/* Set the minimum property and loan value*/
var minValue = 10000;
/* Set the maximum property and loan value*/
var maxValue = 2000000;
/* Set the step value*/
var stepValue = 1000;
/* Set the currency in the unicode value */
/*
 $ \u0024
  \u20AC
  \u00A3
  \u00A5
*/
var calcCurrency = "\u0024";
/* Set the 3 char separator */
var valueSeparator = ",";
var previousValue;

$(function () {
    valueAddComma(loanDefaultValue, "loanValueInt");
    valueAddComma(propertyDefaultValue, "propertyValueInt");
    $("#propertyValueRange").slider(
            { range: "min", value: propertyDefaultValue, min: minValue, max: maxValue, step: stepValue, slide: function (event, ui) { valueAddComma(ui.value, "propertyValueInt"); ltvCalc(); }
            });
    $("#loanValueRange").slider(
            { range: "min", value: loanDefaultValue, min: minValue, max: maxValue, step: stepValue, slide: function (event, ui) { valueAddComma(ui.value, "loanValueInt"); ltvCalc(); }
            });
    $('#propertyValueInt, #loanValueInt').bind({
        blur: function () {
            if (checkValue($(this).attr("id"))) {
                valueAddComma($("#" + $(this).attr("id")).val(), $(this).attr("id"));
                switch ($(this).attr("id").toString()) {
                    case "propertyValueInt":
                        $("#propertyValueRange").slider("value", valueRemoveComma($(this).attr("id")));
                        break;
                    case "loanValueInt":
                        $("#loanValueRange").slider("value", valueRemoveComma($(this).attr("id")));
                        break;
                    default:
                }
                ltvCalc();

            }
            else { valueAddComma(previousValue, $(this).attr("id")); }
        },
        focus: function () {
            $(this).val(valueRemoveComma($(this).attr("id")));
            previousValue = $(this).val();
        }

    });
    ltvCalc();
    $(".calcInfo span").click(function () {
        $(".calcInfo a").slideToggle(250);
    });
});

function valueAddComma(inputValue, inputId) {
    switch (inputValue.toString().length) {
        case 4:
            $("#" + inputId).val( calcCurrency +" "+ inputValue.toString().substr(0, 1) + valueSeparator + inputValue.toString().substr(1, 3));
            break;
        case 5:
            $("#" + inputId).val(calcCurrency + " " + inputValue.toString().substr(0, 2) + valueSeparator + inputValue.toString().substr(2, 4));
            break;
        case 6:
            $("#" + inputId).val(calcCurrency + " " + inputValue.toString().substr(0, 3) + valueSeparator + inputValue.toString().substr(3, 5));
            break;
        case 7:
            $("#" + inputId).val(calcCurrency + " " + inputValue.toString().substr(0, 1) + valueSeparator + inputValue.toString().substr(1, 3) + valueSeparator + inputValue.toString().substr(4, 5));
            break;
        default:
            $("#" + inputId).val(calcCurrency + " " + inputValue.toString());
    }
}

function valueRemoveComma(inputId) {
    var inputValue = $("#" + inputId).val();
    var regex = new RegExp(valueSeparator, "g");
    return inputValue.replace(regex, "").substr(2);
}

function checkValue(inputId) {
    var data = $("#" + inputId).val();
    if (checkNumber(data)) {
        if (checkRange(data)) {
            return true;
        } else {
        showError("Please insert a value within the predefined range!");
            return false;
        }
    } else {
        showError("Please insert a valid amount!");
        return false;
    }

}

function checkNumber(data) {
    var iChars = "0123456789";
    for (var i = 0; i < data.length; i++) {
        if (iChars.indexOf(data.charAt(i)) == -1) {
            return false;
            break;
        }
    }
    return true;
}

function checkRange(data) {
    if (data >= minValue && data <= maxValue) { return true }
    else { return false }
}

function ltvCalc() {
    $(".resultCalc span strong").html(Math.floor(valueRemoveComma("loanValueInt") / valueRemoveComma("propertyValueInt") * 100));
}

function showError(errorText) {
    $(".calcError").html(errorText);
    $('.calcError').fadeIn('slow', function () {
        $('.calcError').delay(1000).fadeOut('slow', function () { });
    });
    
}
